#!/usr/bin/env python
# -*- encoding=iso-8859-2 -*-
# Enumerate usb devices
#
#Copyright 2005 Wander Lairson Costa
# Modified by Wojciech M. Zabolotny
# To receive data from the GPS logger with voice recording
import time
import usb
import array
import bz2

busses = usb.busses()

for bus in busses:
	devices = bus.devices
	for dev in devices:
		if dev.idVendor==0xa5a5 and dev.idProduct==0x0102:
		   print "This is our device!"
		   mydev=dev
		print "Device:", dev.filename
		print "  Device class:",dev.deviceClass
		print "  Device sub class:",dev.deviceSubClass
		print "  Device protocol:",dev.deviceProtocol
		print "  Max packet size:",dev.maxPacketSize
		print "  idVendor:",dev.idVendor
		print "  idProduct:",dev.idProduct
		print "  Device Version:",dev.deviceVersion
		for config in dev.configurations:
			print "  Configuration:", config.value
			print "    Total length:", config.totalLength 
			print "    selfPowered:", config.selfPowered
			print "    remoteWakeup:", config.remoteWakeup
			print "    maxPower:", config.maxPower
			for intf in config.interfaces:
				print "    Interface:",intf[0].interfaceNumber
				for alt in intf:
					print "    Alternate Setting:",alt.alternateSetting
					print "      Interface class:",alt.interfaceClass
					print "      Interface sub class:",alt.interfaceSubClass
					print "      Interface protocol:",alt.interfaceProtocol
					for ep in alt.endpoints:
						print "      Endpoint:",hex(ep.address)
						print "        Type:",ep.type
						print "        Max packet size:",ep.maxPacketSize
						print "        Interval:",ep.interval

def readint():
   f.bulkWrite(1,"\004")
   print f.bulkRead(2,30,500)
def id():
   f.bulkWrite(1,"\000")
   print f.bulkRead(2,30,500)

def stop():
   f.bulkWrite(1,"\003")
   print f.bulkRead(2,30,500)



def prstr(s):
   l=""
   for i in s:
     #print i
     if i<0:
       l+=chr(i+256)
     else:
       l+=chr(i)
   print l
   
def hprint(s):
   l="("
   for i in s:
     #print i
     l+=hex(i)+","     
   l=l[:-1]+")"
   print l

def send_cmd(st,prfl=1):
    f.bulkWrite(1,st,2000)
    #time.sleep(0.5)
    s=f.bulkRead(2,5000,20000)
    if prfl:
      print len(s)
      hprint(s)
      prstr(s)
    return s

f=mydev.open()
f.setConfiguration(mydev.configurations[0])
f.claimInterface(0)
r=send_cmd("M")
r=send_cmd("T")
r=send_cmd("T")
r=send_cmd("T")
fdump=bz2.BZ2File("dump.bin.bz2","wb")
#fdump=open("dump.bin","wb")
vsmp=0
nsmp=0
for i in range(0,100000000):
  if i % 100 == 0:
    print i
  t=send_cmd("R"+chr((i>>24)&0xff)+chr((i>>16)&0xff)+chr((i>>8)&0xff)+chr(i&255),0)
  if t[0]==255 and t[1]==255 and t[2]==255:
    break
  if t[0]==0 and t[1]==0 and t[2]==0:
    break
  s=array.array('B',t[0:512])
  fdump.write(s.tostring())
fdump.close()

